{System/conversion/conversion_progress.i}

DEFINE VARIABLE cProgram                      AS CHARACTER    NO-UNDO.
DEFINE VARIABLE cAction                       AS CHARACTER    NO-UNDO.
DEFINE VARIABLE cTable                        AS CHARACTER    NO-UNDO.
DEFINE VARIABLE iTotal                        AS INTEGER      NO-UNDO.
DEFINE VARIABLE iDone                         AS INTEGER      NO-UNDO.
DEFINE VARIABLE cControl                      AS CHARACTER    NO-UNDO.
DEFINE VARIABLE cCompany                      AS CHARACTER    NO-UNDO.
DEFINE VARIABLE iBooking                      AS INTEGER      NO-UNDO.
DEFINE VARIABLE iLine                         AS INTEGER      NO-UNDO.
DEFINE VARIABLE iTransTeller                  AS INTEGER      NO-UNDO.
DEFINE VARIABLE iTransMax                     AS INTEGER      NO-UNDO INITIAL 500.

DISABLE TRIGGERS FOR LOAD OF dp-control ALLOW-REPLICATION.
DISABLE TRIGGERS FOR LOAD OF dp-vbs_booking ALLOW-REPLICATION.
DISABLE TRIGGERS FOR LOAD OF dp-vbs_booking_line ALLOW-REPLICATION.

DEFINE BUFFER b-dp-control                FOR dp-control.
DEFINE BUFFER b-dp-vbs_booking            FOR dp-vbs_booking.
DEFINE BUFFER b-dp-vbs_booking_line       FOR dp-vbs_booking_line.

ASSIGN
  cProgram = THIS-PROCEDURE:FILE-NAME
  cAction  = "Convert Portbase MCA Road control codes"
  cTable   = "dp-control vbsline"
  iTotal   = 0
  iDone    = 0
  .

/* Handling IDs bij regels invullen */
iTransTeller = 0.
Loop1:
REPEAT TRANSACTION:
  FOR EACH b-dp-control WHERE
           b-dp-control.controlgroup  = "MCA-TRUCK"
       AND b-dp-control.controlname   = "MCA-VBSLINE-HANDLING"
    EXCLUSIVE-LOCK:

    ASSIGN
      iTransTeller  = iTransTeller + 1
      cCompany      = ""
      iBooking      = 0
      iLine         = 0
      .

    cControl = b-dp-control.controlkey1.
    IF NUM-ENTRIES(cControl, "-") = 3
    THEN ASSIGN
          cCompany  = ENTRY(1, cControl, "-")
          iBooking  = INTEGER(ENTRY(2, cControl, "-"))
          iLine     = INTEGER(ENTRY(3, cControl, "-"))
          .
    FIND b-dp-vbs_booking_line WHERE
         b-dp-vbs_booking_line.companycode    = cCompany
     AND b-dp-vbs_booking_line.vbs_bookingnr  = iBooking
     AND b-dp-vbs_booking_line.line_seqnr     = iLine
     EXCLUSIVE-LOCK NO-ERROR.

    IF AVAILABLE b-dp-vbs_booking_line
    THEN b-dp-vbs_booking_line.ext_lineid = b-dp-control.controlvalue.

    DELETE b-dp-control.

    iDone = iDone + 1.

    IF iTransTeller GE iTransMax
    THEN DO:
      RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
      iTransTeller = 0.
      NEXT Loop1.
    END.
  END.

  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  LEAVE Loop1.
END.


/* "Omgekeerde" controlcodes deleten */
iTransTeller = 0.
Loop2:
REPEAT TRANSACTION:
  FOR EACH b-dp-control WHERE
           b-dp-control.controlgroup  = "MCA-TRUCK"
       AND b-dp-control.controlname   = "MCA-HANDLING-VBSLINE"
    EXCLUSIVE-LOCK:

    iTransTeller = iTransTeller + 1.

    DELETE b-dp-control.

    iDone = iDone + 1.

    IF iTransTeller GE iTransMax
    THEN DO:
      RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
      iTransTeller = 0.
      NEXT Loop2.
    END.
  END.

  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  LEAVE Loop2.
END.


cTable   = "dp-control vbsbooking".
iTransTeller = 0.
Loop3:
REPEAT TRANSACTION:
  FOR EACH b-dp-control WHERE
           b-dp-control.controlgroup  = "MCA-TRUCK"
       AND b-dp-control.controlname   = "MCA-VBSBOOKING-VISIT"
    EXCLUSIVE-LOCK:

    iTransTeller = iTransTeller + 1.

    cControl = b-dp-control.controlkey1.
    IF NUM-ENTRIES(cControl, "-") = 2
    THEN ASSIGN
          cCompany  = ENTRY(1, cControl, "-")
          iBooking  = INTEGER(ENTRY(2, cControl, "-"))
          .
    FIND b-dp-vbs_booking WHERE
         b-dp-vbs_booking.companycode    = cCompany
     AND b-dp-vbs_booking.vbs_bookingnr  = iBooking
     EXCLUSIVE-LOCK NO-ERROR.

    IF AVAILABLE b-dp-vbs_booking
    THEN b-dp-vbs_booking.ext_bookingnr = b-dp-control.controlvalue.

    DELETE b-dp-control.

    iDone = iDone + 1.

    IF iTransTeller GE iTransMax
    THEN DO:
      RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
      iTransTeller = 0.
      NEXT Loop3.
    END.
  END.

  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  LEAVE Loop3.
END.


/* "Omgekeerde" controlcodes deleten */
iTransTeller = 0.
Loop4:
REPEAT TRANSACTION:
  FOR EACH b-dp-control WHERE
           b-dp-control.controlgroup  = "MCA-TRUCK"
       AND b-dp-control.controlname   = "MCA-VISIT-VBSBOOKING"
    EXCLUSIVE-LOCK:

    iTransTeller = iTransTeller + 1.

    DELETE b-dp-control.

    iDone = iDone + 1.

    IF iTransTeller GE iTransMax
    THEN DO:
      RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
      iTransTeller = 0.
      NEXT Loop4.
    END.
  END.

  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  LEAVE Loop4.
END.

iTotal = iDone.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).






