{System/conversion/conversion_progress.i}

DEF VAR cProgram                      AS CHARACTER NO-UNDO.
DEF VAR cAction                       AS CHARACTER NO-UNDO.
DEF VAR cTable                        AS CHARACTER NO-UNDO.
DEF VAR iTotal                        AS INTEGER   NO-UNDO.
DEF VAR iDone                         AS INTEGER   NO-UNDO.

DEF VAR cFile                         AS CHARACTER NO-UNDO.
DEF VAR iPos                          AS INTEGER   NO-UNDO.
DEF VAR cExtraHandlingcode            AS CHARACTER NO-UNDO.
DEF VAR cExtraHandlingCodeFilters     AS CHARACTER NO-UNDO.
DEF VAR cDes                          AS CHARACTER NO-UNDO.


DISABLE TRIGGERS FOR LOAD OF dp-control.

DEFINE BUFFER b-dp-control  FOR dp-control.
DEFINE BUFFER b2-dp-control FOR dp-control.
DEFINE BUFFER b-dp-additional_handling FOR dp-additional_handling.

ASSIGN
  cProgram = THIS-PROCEDURE:FILE-NAME
  cAction  = "Convert control codes"
  cTable   = "dp-control"
  iTotal   = 0
  iDone    = 0
  cFile    = ""
  .

DO TRANSACTION:

  servicecode_block:
  FOR EACH dp-servicecode WHERE
           dp-servicecode.servicetype = "HAN"
           NO-LOCK:

    iTotal = iTotal + 1.

    IF iTotal MODULO 10 = 0
    THEN RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

    cExtraHandlingCode = "".
    cDes = "".

    FIND dp-handlingcode WHERE
         dp-handlingcode.handlingcode = dp-servicecode.handlingcode
         NO-LOCK NO-ERROR.

    IF NOT AVAIL dp-handlingcode
    THEN NEXT servicecode_block.

    handlingcode_line_block:
    FOR EACH dp-handlingcode_line WHERE
             dp-handlingcode_line.handlingcode = dp-handlingcode.handlingcode
             NO-LOCK:

      cExtraHandlingCodeFilters = dp-handlingcode_line.des.
      cExtraHandlingCodeFilters = REPLACE(cExtraHandlingCodeFilters, "=", ",").
      cExtraHandlingCodeFilters = REPLACE(cExtraHandlingCodeFilters, CHR(10), ",").

      iPos = LOOKUP("additional_handling", cExtraHandlingCodeFilters).
      IF iPos > 0
      THEN DO:
        cExtraHandlingcode = ENTRY(iPos + 1, cExtrahandlingCodeFilters).
        LEAVE handlingcode_line_block.
      END.
    END.

    IF cExtraHandlingCode <> ""
    THEN DO:

      CASE cExtraHandlingCode:
        WHEN 'BSLASH' THEN cDes = 'Belt/Straps for lashing'.
        WHEN 'CDSTRST' THEN cDes = 'Cross-docking (stripping / stuffing)'.
        WHEN 'CDNWH' THEN cDes = 'Cross-docking cntr Norway-cargo via warehouse'.
        WHEN 'CDBCL' THEN cDes = 'Cross-docking cntr with bales of clothing'.
        WHEN 'CDBBW' THEN cDes = 'Cross-docking cntr with big bags via warehouse'.
        WHEN 'CDPLW' THEN cDes = 'Cross-docking cntr with pallets via warehouse'.
        WHEN 'CDRLP' THEN cDes = 'Cross-docking cntr with reels of paper'.
        WHEN 'CDNWC' THEN cDes = 'Cross-docking container Norway-cargo'.
        WHEN 'CDVATS' THEN cDes = 'Cross-docking container VAT-cargo (start)'.
        WHEN 'CDPLT' THEN cDes = 'Cross-docking container with pallets'.
        WHEN 'CDSAM' THEN cDes = 'Cross-docking Samskip cargo (incl. documents)'.
        WHEN 'DUNN' THEN cDes = 'Dunnage bags used'.
        WHEN 'LASH' THEN cDes = 'Lashing'.
        WHEN 'REWR' THEN cDes = 'Re-wrap per pallet'.
        WHEN 'SECUR' THEN cDes = 'Securing cargo'.
        WHEN 'AFDOM' THEN cDes = 'Afmelden DOMPROC'.
        WHEN 'AFT1' THEN cDes = 'Afmelden T1'.
        WHEN 'T1' THEN cDes = 'Creating T1-document'.
        WHEN 'FYCO' THEN cDes = 'FyCo Customs'.
        WHEN 'FOP' THEN cDes = 'Handling for FOP'.
        WHEN 'BUND' THEN cDes = 'Bundeling / ontbundeling flats'.
        WHEN 'UNLAB' THEN cDes = '(Un)labeling container'.
        WHEN 'SEAL' THEN cDes = 'Containerseal'.
        WHEN 'SLCH' THEN cDes = 'Seal Check'.
        WHEN 'GASYRD' THEN cDes = 'Extra move to gasmeasurement yard'.
        WHEN 'CROSS' THEN cDes = 'Extra move cross-docking'.
        WHEN 'PENBAS' THEN cDes = 'Pendel TMA - C.J. Hendriks Basisweg'.
        WHEN 'PENGYR' THEN cDes = 'Pendel TMA - C.J. Hendriks Gyroscoopweg'.
        WHEN 'PENKOP' THEN cDes = 'Pendel TMA - C.J. Hendriks Kopraweg'.
        WHEN 'PENLAT' THEN cDes = 'Pendel TMA - C.J. Hendriks Latexweg'.
        WHEN 'PENNVT' THEN cDes = 'Pendel TMA - Neele-VAT Logistics'.
        WHEN 'PENVOS' THEN cDes = 'Pendel TMA - Vosse Transport'.
        WHEN 'PEND' THEN cDes = 'Pendel container'.
        WHEN 'TWIST' THEN cDes = 'Handling twistlocks container'.
        WHEN 'CHAIN' THEN cDes = 'Chainlift'.
        WHEN 'EXTRA' THEN cDes = 'Extra Move'.
        WHEN 'CLEAR' THEN cDes = 'Extra Move to clear container'.
        WHEN 'GASM' THEN cDes = 'Gasmeasurement'.
        WHEN 'WEIGHC' THEN cDes = 'Weighing Container'.
        WHEN 'OVERH' THEN cDes = 'Loading cnt/fl with overheight spreader'.
        WHEN 'WEIGHS' THEN cDes = 'Weighing service'.
        WHEN 'SURREACH' THEN cDes = 'Surcharge Reachstacker'.
        WHEN 'RFPL' THEN cDes = 'Reefer Plug-in'.
        WHEN 'PHOTOFEE' THEN cDes = 'Photo fee'.
        WHEN 'PHOTOTAKEN' THEN cDes = 'Photo taken'.
      END CASE.

      FIND b-dp-additional_handling WHERE
           b-dp-additional_handling.additional_handlingcode = cExtraHandlingCode
           EXCLUSIVE-LOCK NO-ERROR.
      IF NOT AVAIL b-dp-additional_handling
      THEN DO:
        CREATE dp-additional_handling.
        ASSIGN dp-additional_handling.companycode = dp-servicecode.companycode
               dp-additional_handling.additional_handlingcode = cExtraHandlingCode
               dp-additional_handling.des = cDes
               .
      END.

    END.

  END.

END.

iTotal = iDone.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).






